c  SAKITOPO - see prof_programs, SAKI
c
c  This program outputs a single-row grid of the topo surface of a saki
c  model.  Input is model file used with SAKI, the vertices that represent
c  the top surface of the model, the total number of vertices in the
c  SAKI bfile, and xo, yo, dx, and nobs.
c  OUTPUT TOPO has datum removed so that the lowest place is 0 and 
c  becomes Z POSITIVE UP.
c  Tien Grauch
      character*50 bfile,ofile
      dimension xb(50),zb(50),zf(100),xf(100),id(14),pgm(2),itopo(50)
      print*,'Enter saki bfile name'
      read 800,bfile
      open(10,file=bfile,form='formatted',status='old',readonly,
     1err=298,carriagecontrol='list')
800   format(a50)
      print*,'Enter total no. of body veritces in bfile'
      read*,nvert
      read(10,*,err=297) (xb(i),zb(i),i=1,nvert)
      print*,'Enter no. of vertices that define topo surface'
      read*,ntopo
      print 801,ntopo
801   format(' Enter the ',i2,' vertice numbers that define topo surf in
     1 left to right order')
      read*,(itopo(i),i=1,ntopo)
      print*,'Enter xo,yo,dx, and nobs'
      read*,xo,yo,dx,nobs
      print*,'Enter output grid name'
      read 800,ofile
      open(11,file=ofile,form='unformatted',status='new')
      nz=1
      nrow=1
      pgm(1)='saki'
      pgm(2)='topo'
      print*,'Enter title'
      read 802,id
802   format(14a4)
      write(11) id,pgm,nobs,nrow,nz,xo,dx,yo,dx
      zmax=-1.e+38
	do 45 i=1,nobs
	xf(i)=xo+float(i-1)*dx
	zf(i)=zb(itopo(1))
      if(xf(i).gt.xb(itopo(1)).and.xf(i).lt.xb(itopo(ntopo))) go to 30
	if(xf(i).gt.xb(itopo(ntopo))) zf(i)=zb(itopo(ntopo))
	go to 40
30	j=1
31	if(j.ge.ntopo) go to 40
	k=itopo(j)
	k1=itopo(j+1)
	if(xf(i).ge.xb(k) .and. xf(i).lt.xb(k1)) go to 39
	j=j+1
	go to 31
39	zf(i)=(xf(i)-xb(k))*(zb(k1)-zb(k))/(xb(k1)-xb(k))+zb(k)
40    if(zf(i).gt.zmax) zmax=zf(i)
45	continue
c change to z pos. up and make lowest area 0
      do 50 i=1,nobs
      zf(i)=zmax-zf(i)
50    continue
      write(11) dum,(zf(i),i=1,nobs)
      print*,'  Output has datum removed so that lowest pt is 0'
      close(10)
      close(11)
      go to 300
297   print*,'Something wrong while reading bfile'
      close(10)
      go to 300
298   print*,'Input file not found or not ascii'
300   stop
      end
