c  SHADE.FOR
c          there are two options in the program which are set 
c          by the variable hderiv.if hderiv = 'n' then the raw profile
c          data are plotted with no shading;otherwise the
c          following comments apply.
c          program computes an approximate second horizontal
c          derivative of profile data(usually aeromagnetic)
c          and plots profiles at true ground position with
c          a designated root amplitude of
c          the derivative value added to the ground y position.
c          the positive values are also shaded.
c          the subroutines cur1 and shder2 are included but
c          not used at present.they work fine if there are
c          no dval's in a profile and they are a little faster.
c          r.godson,usgs,9/88
c
          character*1 ans,hderiv
          character*4 type
          character*56 infile,cfile
          real latm,latx,longm,longx
          dimension xs(4),ys(4),jdim(1),jline(2)
        common /llp/ latm(3),latx(3),longm(3),longx(3),cm(3),
     1               baslat(3),
     1    iproj,xxx(2),yyy(2),sizep,unit,iplotr,neat,tint,itpost,
     1    ib
          namelist/parms/infile,scal,root,type,angle,ival,
     &    jline,iskip,hderiv,vscale,latm,latx,longm,longx,
     &    cm,baslat,tint,itpost,iplotr,iproj
          data icard/5/,iprint/6/,in/10/,in1/11/,jdim(1)/0/,
     & intkm/39370.079/,fac/.001/
        data d2r/1.7453292e-2/, conm/1.666667e-2/,
     1       cons/2.777778e-4/
        dms2d(a,b,c)=a+sign(b,a)*conm+sign(c,a)*cons
          root=4.
          sizep=.1
          unit=2
          iskip=1
          angle=0.
          hderiv='y'
          vscale=0.
          write(iprint,900)
900       format(' are you entering commands interactively?(y/n)'$)
          read(icard,1465) ans
          if(ans.ne.'y'.and.ans.ne.'Y') go to 3
          write(iprint,925)
925       format(' do you want 2nd horizontal derivative',
     &    ' and shading(y/n): ',$)
          read(icard,1465) hderiv
          if(hderiv.ne.'y'.and.hderiv.ne.'Y') then
          write(iprint,950)
950       format(' enter vertical scale for raw profiles: ',$)
          read(icard,*) vscale
          endif
          write(iprint,1000)
1000      format(' enter min & max latitude in deg,min,sec(6 values):'$)
          read(icard,*) latm,latx
          write(iprint,1200)
1200      format(' enter right & left longtitude',
     & ' in deg,min,sec(6 values):'$)
          read(icard,*) longm,longx
          write(iprint,1400)
1400      format(' enter central meridian & baslat(6 values): '$)
          read(icard,*) cm,baslat
          write(iprint,1410)
1410      format(' enter map scale,projection no.,plotter no.',
     & /,' lat/lon tick interval(minutes)',
     & '(if 0 no ticks are plotted)&',
     & /,' tick labelling interval(integer)(if 0 no labelling)',
     & /,': '$)
          read(icard,*) scal,iproj,iplotr,tint,itpost
          write(iprint,1425)
1425  format(' enter amplitude root factor(e.g.2,4,etc.): ',$)
          read(icard,*) root
          write(iprint,1450)
1450      format(' enter input file name: '$)
          read(icard,1465) infile
1465      format(a)
          write(6,1470)
1470      format(' enter type of file(post,grid or airb):'$)
          read(icard,1465) type
          if(type.eq.'post') then
          write(iprint,1475)
1475      format(' enter angle of lines(0=e-w;90=n-s):'$)
          read(icard,*) angle
          write(iprint,1480)
1480      format(' enter post  z no. & beg & end line no. & skip: '$)
          read(icard,*) ival,jline,iskip
          ival=ival+2
          else if(type.eq.'grid') then
          write(iprint,1490)
1490      format(' enter beg & end row numbers: '$)
          read(icard,*) jline
          else if(type.eq.'airb') then
          write(iprint,1475)
          read(icard,*) angle
          write(iprint,1492)
1492     format(' enter channel number,beg & end line no. & skip:'$)
          read(icard,*) ival,jline,iskip
          endif
          go to 4
3         write(iprint,1495)
1495      format(' enter command file name: '$)
          read(icard,1465) cfile
          open(9,file=cfile,status='unknown')
          read(9,parms)
4         scal=scal/intkm
          if(hderiv.ne.'y'.and.hderiv.ne.'Y') then
          if(vscale.eq.0.) then
          print *,'vertical scale not specified for raw profiles'
          stop
          endif
          endif
          if(type.eq.'POST') type='post'
          if(type.eq.'GRID') type='grid'
          if(type.eq.'AIRB') type='airb'
          open(in,file=infile,status='unknown',form='unformatted',
     &    readonly)

c
c         plot system initialization
c
c         determine min/max
c
          xlatm=dms2d(latm(1),latm(2),latm(3))
          xlongm=dms2d(longm(1),longm(2),longm(3))
          xlatx=dms2d(latx(1),latx(2),latx(3))
          xlongx=dms2d(longx(1),longx(2),longx(3))
          bld=dms2d(baslat(1),baslat(2),baslat(3))
          cmd=dms2d(cm(1),cm(2),cm(3))
          if(iproj.gt.4.and.iproj.lt.8) call setalb(iproj)
          call prjctl(bld,cmd,xxxx,pbs,cmd,fac,iproj)
          call prjctl(xlatm,xlongx,xxxx,yyyy,cmd,fac,iproj)
          xmin=xxxx
          ymin=yyyy-pbs
          call prjctl(xlatx,xlongx,xxxx,yyyy,cmd,fac,iproj)
          xxmin=xxxx
          ymax=yyyy-pbs
          call prjctl(xlatm,xlongm,xxxx,yyyy,cmd,fac,iproj)
          xmax=xxxx
          yymin=yyyy-pbs
          call prjctl(xlatx,xlongm,xxxx,yyyy,cmd,fac,iproj)
          xxmax=xxxx
          yymax=yyyy-pbs
          xxx(1)=amin1(xmin,xxmin,xmax,xxmax)
          xxx(2)=amax1(xmin,xxmin,xmax,xxmax)
          yyy(1)=amin1(ymin,yymin,ymax,yymax)
          yyy(2)=amax1(ymin,yymin,ymax,yymax)
          call prjctl(xlatm,cmd,xxxx,yyyy,cmd,fac,iproj)
          if(xxxx.gt.xxx(1).and.xxxx.lt.xxx(2)) yyy(1)=yyyy-pbs
          xs(1)=(xxx(2)-xxx(1))/scal
          ys(1)=(yyy(2)-yyy(1))/scal
          xs(2)=0.
          ys(2)=0.
          xs(3)=1.
          ys(3)=1.
          xs(4)=xs(1)+xs(3)+1.
          ys(4)=ys(1)+ys(3)+1.
          write(iprint,1500) xs(4),ys(4)
1500      format(/' size of plot(inches) in x = ',f7.1,' in y = ',f7.1)
          call pltset(iplotr,xbd,ybd,jdim)
          call scale(xxx,yyy,xs,ys,4,icode)
          if(tint.eq.0.) go to 5
c
c         plot lat/lon tick marks
c
          call llpost
    5     call mplot(in,type,ival,angle,scal,
     &  jline,root,iskip,iplotr,hderiv,vscale)
          call endpt(jdim)
          stop
          end
c**********
        subroutine llpost
        common /llp/ latm(3),latx(3),longm(3),longx(3),cm(3),
     1               baslat(3),
     1    iproj,xxx(2),yyy(2),sizep,unit,iplotr,neat,tint,itpost,
     1    ib
        dimension scaf(3),range(2),xx(2),yy(2)
        real latm,latx,longm,longx
        character fmt*16
        logical nos,nom
        data d2r/1.7453292e-2/, conm/1.666667e-2/,
     1       cons/2.777778e-4/,
     1    scaf/39.370079,1.,.001/, icross/6/,
     1    nmax/10/
        dms2d(a,b,c)=a+sign(b,a)*conm+sign(c,a)*cons
c
        if(iproj.lt.1 .or.iproj.gt.10) return
        sca=scaf(int(unit)+1)
        do 1 i=1,2
        xx(i)=xxx(i)/(1000.*sca)
1       yy(i)=yyy(i)/(1000.*sca)
        hfx=.5*(xx(1)+xx(2))
        hfy=.5*(yy(1)+yy(2))
        if(iproj.gt.4) call setalb(iproj)
        bld=dms2d(baslat(1),baslat(2),baslat(3))
        cmd=dms2d(cm(1),cm(2),cm(3))
        if(abs(bld).gt.90. .or. abs(cmd).gt.360.) return
        call prjctl(bld,cmd,xb,yb,cmd,sca,iproj)
        ydm=dms2d(latm(1),latm(2),latm(3))
        ydx=dms2d(latx(1),latx(2),latx(3))
        xdx=dms2d(longm(1),longm(2),longm(3))
        xdm=dms2d(longx(1),longx(2),longx(3))
c  adjust cem for conic prjctlion distance to equator
        cem=4.0e7
        if(iproj.eq.4 .and. abs(bld).lt.15.) cem=4.21e7
        if(iproj.gt.4 .and. abs(bld).lt.15.) cem=3.84e7
        ce=cem*sca
        dt=(yy(2)-yy(1))*360./(ce*5.)
c  min-max latitude of area
        if(ydm.ge.ydx) go to 9
        if(ydm.ne.0.0 .and. ydx.ne.0.0) go to 10
9       ydm=bld+(yy(1)*360.)/ce-dt
        ydx=bld+(yy(2)*360.)/ce+dt
        if(ydm.lt.-90.0) ydm=-90.0
        if(ydx.gt.90.0)  ydx=90.0
        latx(1)=ydx
        latm(1)=ydm
c  min-max longitude of area
10      if(xdm.ne.0.0 .and. xdx.ne.0.0) go to 20
        cosp=cos(d2r*amax1(abs(ydx),abs(ydm)))
        if(cosp.lt..17364) cosp=.17364
        xdm=cmd+(xx(1)*360.)/(cosp*ce)-dt
        xdx=cmd+(xx(2)*360.)/(cosp*ce)+dt
        longm(1)=xdx
        longx(1)=xdm
c  default tick interval for less than nmax ticks per side
c  result is multiple of 1, 2 or 5 deg, min, or, sec
20      if(tint.gt.0.0) go to 30
        range(1)=0.
        range(2)=amax1((xdx-xdm),(ydx-ydm))
        tint=0.
        dr=range(2)*60./float(nmax)
        if(dr.ge.60.) then
         call setax(range,tint,nmax,ndum,fmt)
         tint=tint*60.
        else if(dr.ge.1. .and. dr.lt.60.) then
         range(2)=range(2)*60.
         call setax(range,tint,nmax,ndum,fmt)
        else
         range(2)=range(2)*3600.
         call setax(range,tint,nmax,ndum,fmt)
         tint=tint/60.
        endif
c  final initialization
30      if(itpost.le.0) itpost=2
        dt=(aint(tint*60.+.0001))/3600.
        dt2=dt*float(itpost)
        dt3=dt2*60.0
        nos=.false.
        if(dt3-aint(dt3).eq.0.0) nos=.true.
        nom=.false.
        if(amod(dt3,60.0).eq.0.0) nom=.true.
        if(yy(2)-yy(1).lt.20.)  ydm=aint(60.*ydm)/60.
        if(yy(2)-yy(1).ge.20.)  ydm=aint(ydm+90.)-90.
        if(yy(2)-yy(1).gt.500.) ydm=5.*aint((ydm+90.)/5.) - 90.
        if(xx(2)-xx(1).lt.20.)  xdm=aint(60.*xdm)/60.
        if(xx(2)-xx(1).ge.20.)  xdm=aint(xdm+360.)-360.
c     utm has a limit of 3 degrees
        if(xx(2)-xx(1).gt.500. .and. iproj.ne.2)
     1    xdm=5.*aint((xdm+360.)/5.) - 360.
c  plot longitude labels
        if(sizep.le.0.0) return
        xd=xdm
100     if(xd.gt.xdx) go to 190
        call dms(xd,id,im,is)
        id=id
        yd=ydm
105     call prjctl(yd,xd,x,y,cmd,sca,iproj)
        y=y-yb
        if(x.ge.xx(1).and.x.le.xx(2) .and.
     1    y.ge.yy(1).and.y.lt.hfy) go to 109
        yd=yd+dt
        if(yd-ydx) 105,105,110
109     call latlab(-1.,0,sizep,x,yy(1),id,im,is,nos,nom)
110     if(iplotr.eq.1 .or. iplotr.eq.4) go to 120
        yd=ydx
115     call prjctl(yd,xd,x,y,cmd,sca,iproj)
        y=y-yb
        if(x.ge.xx(1).and.x.le.xx(2) .and.
     1    y.gt.hfy.and.y.le.yy(2)) go to 119
        yd=yd-dt
        if(yd-ydm) 120,115,115
119     call latlab(1.,0,sizep,x,yy(2),id,im,is,nos,nom)
120     xd=xd+dt2
        go to 100
c  plot latitude labels
190     yd=ydm
200     if(yd.gt.ydx) go to 300
        call dms(yd,id,im,is)
        xd=xdm
205     call prjctl(yd,xd,x,y,cmd,sca,iproj)
        y=y-yb
        if(y.ge.yy(1).and.y.le.yy(2) .and.
     1    x.ge.xx(1).and.x.lt.hfx) go to 209
        xd=xd+dt
        if(xd-xdx) 205,205,210
209     call latlab(-1.,1,sizep,xx(1),y,id,im,is,nos,nom)
210     if(iplotr.eq.1 .or. iplotr.eq.4) go to 220
        xd=xdx
215     call prjctl(yd,xd,x,y,cmd,sca,iproj)
        y=y-yb
        if(y.ge.yy(1).and.y.le.yy(2) .and.
     1    x.gt.hfx.and.x.le.xx(2)) go to 219
        xd=xd-dt
        if(xd-xdm) 220,215,215
219     call latlab(1.,1,sizep,xx(2),y,id,im,is,nos,nom)
220     yd=yd+dt2
        go to 200
c  plot interior lat-lon ticks
300     yd=ydm
        do 360 j=1,int((ydx-yd)/dt)+1
        xd=xdm
        do 350 i=1,int((xdx-xd)/dt)+1
        call prjctl(yd,xd,x,y,cmd,sca,iproj)
        y=y-yb
        if(x.lt.xx(1) .or. x.gt.xx(2)) go to 350
        if(y.lt.yy(1) .or. y.gt.yy(2)) go to 350
        if(sizep.lt..00025) then
          call vchar(x,y,icross,1,2,2000.0*sizep,0.,0.,0.)
        else
          call vchar(x,y,icross,1,2,2.0*sizep,0.,0.,0.)
        end if
350     xd=xd+dt
360     yd=yd+dt
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  D M S
C________________________________________________________________
C
        subroutine dms(d,id,im,is)
        is=int(abs(d)*3600.+.5)
        id=is/3600
        im=(is-id*3600)/60
        is=is-(id*3600+im*60)
        id=isign(id,int(d))
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  L A T L A B
C________________________________________________________________
C
        subroutine latlab(side,lat,sz,x,y,jd,jm,js,nosec,nomin)
        dimension labint(3)
        character label*12,jd2*1,jm2*1,js2*1
        equivalence (labint,label)
        logical nosec,nomin
        jd2=char(24)
        jm2=char(39)
        js2=char(34)
        write(label,50) iabs(jd),jd2,jm,jm2,js,js2
50      format(i4,a1,2(i2,a1))
        if(jm.ne.0 .or. js.ne.0) nomin=.false.
        if(js.ne.0) nosec=.false.
        nch=11
        if(nosec) nch=8
        if(nomin) nch=5
        xl=nch*sz
        yof=0.
        if(lat.eq.1) then
        if(side.lt.0.) xof=-(2.*sz+xl)
        if(side.gt.0.) xof=2.*sz
        else
        xof=-xl/2.
        yof=2.*sz*side
        endif
        call vchar(x,y,labint,nch,2,sz,0.,xof,yof)
        return
        end
      subroutine setax(x,dx,maxint,nch,fmt)
c  adjust interval and labeling format
c  input x-min max range, optional dx-spacing and
c  maxint-intervals
c  returns dx, nch-number of significant figures, fmt-labeling
c  format
      dimension x(2)
      character fmt*(*)
      ixpn(r)=int(alog10(abs(r))+100.)-100
      fmt='(1pe13.6)'
      nch=13
      if(dx.ne.0.) go to 5
      if(maxint.le.0) maxint=20
      t=(x(2)-x(1))/float(maxint)
      if(t.lt.1.e-20) return
      p10=sign(1.0,t)*10.**ixpn(t)
      t1=t/p10
      if(t1.le.1.0) dx=p10
      if(t1.gt.1.0) dx=2.*p10
      if(t1.gt.2.0) dx=5.*p10
      if(t1.gt.5.0) dx=10.*p10
    5 idecm=0
      n10=ixpn(dx)
      if(n10.lt.0) idecm=iabs(n10)
      n10=ixpn( amax1(abs(x(1)),abs(x(2))) )
      iw=4+idecm
      if(n10.ge.0) iw=3+n10+idecm
      if(iw.gt.9) go to 11
      write(fmt,10) iw,idecm
   10 format('(f',i1,'.',i1,')' )
      nch=iw
      if(idecm.eq.0) nch=nch-1
   11 return
      end
      subroutine mplot(in,type,ival,angle,scal,
     & jline,root,iskip,iplotr,hderiv,vscale)
      character*1 hderiv
      parameter(ndim=10000,maxch=24)
      character*4 type,idd(2),mline,lline
      character*8 date2
      character*56 infile
      character*64 head
      real kmthin
      dimension zz(maxch),z2(100,maxch),
     & xi(ndim),yi(ndim),zi(ndim),yi1(ndim),jline(2),
     & exi(ndim-2),eyi1(ndim-2),isort(ndim),tcurv1(ndim)
      dimension zin(ndim,3),zout(ndim,3),title(4)
      equivalence(zout(1,1),xi(1)),(zout(1,2),yi(1)),
     & (zout(1,3),yi1(1))
      double precision airx(100),airy(100),xdum(4)
      equivalence(xi(2),exi(1)),(yi1(2),eyi1(1))
      data dval/1.e37/
      isw=0
      kline=0
      nline=0
      mxline=jline(2)-jline(1)+1
      rc=cos(angle*.1745329e-1)
      rs=sin(angle*.1745329e-1)
      kmthin=scal*.0075
      vscal=scal*(.1/root)
      power=1./root
      if(type.eq.'post') then
      itype=1
      else if(type.eq.'grid') then
      itype=2
      read(in)head,ncol,nrow,nz,xo,dx,yo,dy
      if(ncol.gt.ndim) then
      print *,'number of input points',ncol,' gt',ndim
      stop
      endif
      zout(1,1)=xo
      zout(1,2)=yo
      do 10 i=2,ncol
      zout(i,1)=zout(i-1,1)+dx
      zout(i,2)=yo
   10 continue
      npts=ncol
      else
      itype=3
      read(in) title,nmax,nch,date2,delt
      if(nch.gt.maxch) then
      print *,'number of input channels',nch,' gt',maxch
      stop
      endif
      endif
      go to (20,32,33),itype
c
c     post format
c
   20 nword=lenrec(in)
      nz=nword-2
      if(nz.gt.maxch) then
      print *,'number of input channels',nz,' gt',maxch
      stop
      endif
      call io(idd,zz,nz,in,1,ierr)
      if(ierr.lt.0) go to 31
      i=1
      zin(i,1)=zz(1)*rc+zz(2)*rs
      zin(i,2)=zz(2)*rc+zz(1)*rs
      zin(i,3)=zz(ival)
      lline=idd(1)
   30 call io(idd,zz,nz,in,1,ierr)
      if(ierr.lt.0) go to 31
      if(idd(1).eq.lline) then
      i=i+1
      if(i.gt.ndim) then
      print *,'number of input points',i,' gt',ndim
      stop
      endif
      zin(i,1)=zz(1)*rc+zz(2)*rs
      zin(i,2)=zz(2)*rc+zz(1)*rs
      zin(i,3)=zz(ival)
      go to 30
      else
      read(lline,25) kline
   25 format(i4)
   27 if(kline.lt.jline(1).or.kline.gt.jline(2)) go to 65
      npts=i
      go to 37
      endif
   31 isw=1
      read(idd(1),25) kline
      go to 27
c
c     grid format
c
   32 kline=kline+1
      if(kline.gt.nrow) go to 70
      read(in) dum,(zout(j,3),j=1,ncol)
      if(kline.ne.1) then
      do 29 i=1,ncol
      zout(i,2)=zout(i,2)+dy
   29 continue
      endif
      if(kline.lt.jline(1).or.kline.gt.jline(2)) go to 32
      go to 37
c
c     airborne format
c
   33 read(in,end=70) iline,its,nobs,isid,xdum,(airx(k),
     & airy(k),(z2(k,j),j=1,nch),k=1,nobs)
      kline=iline
      i=0
      do 35 j=1,nobs
      i=i+1
      zin(i,1)=sngl(airx(j)*rc+airy(j)*rs)
      zin(i,2)=sngl(airy(j)*rc+airx(j)*rs)
      zin(i,3)=z2(j,ival)
   35 continue
   34 read(in,end=38) iline,its,nobs,isid,xdum,(airx(k),
     & airy(k),(z2(k,j),j=1,nch),k=1,nobs)
      if(iline.eq.kline) then
      do 36 j=1,nobs
      i=i+1
      if(i.gt.ndim) then
      print *,'number of input points',i,' gt',ndim
      stop
      endif
      zin(i,1)=sngl(airx(j)*rc+airy(j)*rs)
      zin(i,2)=sngl(airy(j)*rc+airx(j)*rs)
      zin(i,3)=z2(j,ival)
   36 continue
      go to 34
      else
      if(kline.lt.jline(1).or.kline.gt.jline(2)) go to 65
      npts=i
      go to 37
      endif
   38 isw=1
      npts=i
      if(kline.lt.jline(1).or.kline.gt.jline(2)) go to 65
   37 if(iplotr.ne.1.and.iplotr.ne.4.and.iplotr.lt.7)
     & write(6,39) kline,npts
   39 format(' line= 'i4,' npts= ',i5)
      nline=nline+1
c
c      sort profile if data is nongridded
c
      if(itype.eq.2) go to 49
      call hrsort(zin,zout,isort,npts,ndim,3,ndim,1,ier)
      if(ier.ne.0) then
      print *,' error no. ',ier,' in sort subroutine'
      stop
      endif
c
c
c     decimate number of input points
c
      if(iskip.le.1) go to 49
      j=0
      do 40 i=1,npts,iskip
      j=j+1
      zout(j,1)=zout(i,1)
      zout(j,2)=zout(i,2)
      zout(j,3)=zout(i,3)
   40 continue
      npts=j
      go to 49
   44 sigma=-5.
c
c
c     calculate second horizontal derivative
c
   45 call cur1(npts,zout(1,1),zout(1,3),slp1,slp2,
     & tcurv1,zi,sigma)
c
c     calculate amplitude
c
c  49 call shder2(tcurv1,zi,ndim,npts,power)
c
c     check to see if only raw profiles are desired
c
   49 if(hderiv.ne.'y'.and.hderiv.ne.'Y') then
      sum=0.
      k=0
      do 50 i=1,npts
      if(yi1(i).gt.dval) go to 50
      k=k+1
      sum=sum+yi1(i)
   50 continue
      if(k.gt.0) then
      xmean=sum/k
      else
      go to 65
      endif
      do 55 i=1,npts
      if(yi1(i).gt.dval) then
      temp=0.
      else
      temp=(yi1(i)-xmean)/vscale
      endif
      yi1(i)=yi(i) + temp*scal
   55 continue
c
c     plot profile
c
      if(angle.gt.45.) then
      call line(yi1,xi,npts,0,0)
      else
      call line(xi,yi1,npts,0,0)
      endif
      go to 65
      else
c
c     calculate approx. second horizontal derivative
c     and amplitude
c
      call shder(zout,zi,ndim,npts,power,itype)
      do 60 j=2,npts-1
      yi1(j)=yi(j)+zi(j)*vscal
   60 continue
 
c
c     plot profile
c
      if(angle.gt.45.) then
      call line(eyi1,exi,npts-2,0,0)
      else
      call line(exi,eyi1,npts-2,0,0)
      endif
c
c     fill in positive amplitudes
c
      call fill(xi,yi,yi1,zi,kmthin,npts,angle)
      endif
c
c     initialize start of next line
c
   65 if(nline.eq.mxline.or.isw.eq.1) go to 70
      if(type.eq.'grid') go to 32
      if(type.eq.'post') then
      lline=idd(1)
      i=1
      zin(i,1)=zz(1)*rc+zz(2)*rs
      zin(i,2)=zz(2)*rc+zz(1)*rs
      zin(i,3)=zz(ival)
      else
      kline=iline
      k=0
      do 67 j=i-nobs+1,i
      k=k+1
      zin(k,1)=zin(j,1)
      zin(k,2)=zin(j,2)
      zin(k,3)=zin(j,3)
   67 continue
      i=k
      endif
      go to (30,32,34),itype
   70 return
      end
      subroutine shder(zout,zi,ndim,npts,power,itype)
c
c     computes a designated root of
c     1/2 the second differences of a profile
c
      dimension zout(ndim,3),zi(ndim)
      data dval/1.e37/
      if(itype.eq.2) go to 5
c
c     non-gridded data
c
c     this section will blow up with divide by zero
c     if there are duplicate x positions
c
      do 3 i=2,npts-1
      if(zout(i-1,1).eq.zout(i,1).or.zout(i+1,1)
     & .eq.zout(i,1)) then
      zi(i)=0.
      go to 3
      endif
      temp=((zout(i,3)-zout(i-1,3))/(zout(i,1)-zout(i-1,1))-
     & (zout(i+1,3)-zout(i,3))/(zout(i+1,1)-zout(i,1)))
     & /(zout(i+1,1)-zout(i-1,1))
      zi(i)=sign(abs(temp)**power,temp)
      if(abs(zi(i)).gt.25.) zi(i)=0.
   3  continue
      return
c
c     gridded data
c
    5 do 10 i=2,npts-1
      if(zout(i-1,3).gt.dval.or.zout(i,3).gt.dval
     $ .or.zout(i+1,3).gt.dval) then
      zi(i)=0.
      else
      temp=((zout(i,3)-zout(i-1,3))/(zout(i,1)-zout(i-1,1))-
     & (zout(i+1,3)-zout(i,3))/(zout(i+1,1)-zout(i,1)))
     & /(zout(i+1,1)-zout(i-1,1))
      zi(i)=sign(abs(temp)**power,temp)
      if(abs(zi(i)).gt.25.) zi(i)=0.
      endif
   10 continue
      return
      end

      subroutine shder2(tcurv1,zi,ndim,npts,power)
c
c     compute amplitude
c
      dimension tcurv1(ndim),zi(ndim)
      do 10 i=2,npts-1
      temp=-10.*tcurv1(i)
      zi(i)=sign(abs(temp)**power,temp)
      if(abs(zi(i)).gt.25.) zi(i)=0.
   10 continue
      return
      end
c**********
      subroutine fill(xi,yi,yi1,zi,kmthin,npts,angle)
c
c     fills in positive amplitudes
c
      real kmthin
      dimension xi(npts),yi(npts),yi1(npts),zi(npts),
     & xx(2),yy(2)
      do 60 j=2,npts-2
      if(zi(j).gt.0..or.zi(j+1).gt.0.) then
      if(zi(j).gt.0..and.zi(j+1).gt.0.) then
      ratio=1.
      xint=0.
      yint=0.
      yint1=0.
      else if(zi(j).gt.0.) then
      ratio=abs(zi(j)/(zi(j)-zi(j+1)))
      xint=0.
      yint=0.
      yint1=0.
      else
      ratio=abs(zi(j+1)/(zi(j)-zi(j+1)))
      tratio=1.-ratio
      xint=tratio*(xi(j+1)-xi(j))
      yint=tratio*(yi(j+1)-yi(j))
      yint1=tratio*(yi1(j+1)-yi1(j))
      endif
      absxi=abs(xi(j)-xi(j+1))*ratio
      xnnt=absxi/kmthin
      nnt=nint(xnnt)
      if(nnt.lt.1) nnt=1
      xinc=kmthin
      yinc=(yi(j+1)-yi(j))*ratio/xnnt
      yinc1=(yi1(j+1)-yi1(j))*ratio/xnnt
      do 50 k=1,nnt
      xx(1)=xi(j)+xint
      xx(2)=xx(1)
      yy(1)=yi(j)+yint
      yy(2)=yi1(j)+yint1
      if(angle.gt.45.) then
      call line(yy,xx,2,0,0)
      else
      call line(xx,yy,2,0,0)
      endif
      xint=xint+xinc
      yint=yint+yinc
      yint1=yint1+yinc1
   50 continue
      endif
   60 continue
      return
      end
c*********
      subroutine io(idd,z,n,idev,irw,ierr)
c
c     reads a post record
c
      character*4 idd(2)
      dimension z(n)
      ierr=0
      go to (10,20),irw
   10 read(idev,end=30) idd,z
      return
   20 write(idev) z
      return
   30 ierr=-1
      return
      end
c*********
      function lenrec(idev)
c
c     find the number of words in a record
c
      dimension iz(24)
      do 20 lenrec=24,1,-1
      read(idev,err=10) (iz(i),i=1,lenrec)
      go to 30
   10 rewind idev
   20 continue
   30 rewind idev
      return
      end
          subroutine cur1(n,x,y,slp1, slpn, yp,temp,sigma)
          real x(1), y(1),slp1, slpn, yp(1), temp(1), sigma
c THIS SUBROUTINE DETERMINES THE PARAMETERS NECESSARY TO
c COMPUTE AN INTERPOLATORY SPLINE UNDER TENSION THROUGH
c A SEQUENCE OF FUNCTIONAL VALUES. THE SLOPES AT THE TWO
c ENDS OF THE CURVE MAY BE SPECIFIED OR OMITTED. FOR ACTUAL
c COMPUTATION OF POINTS ON THE CURVE IT IS NECESSARY TO CALL
c THE FUNCTION CURV2.
c ON INPUT--
c N IS THE NUMBER OF VALUES TO BE INTERPOLATED (N.GE.2),
c X IS AN ARRAY OF THE N INCREASING ABSCISSAE OF THE
c FUNCTIONAL VALUES,
c Y IS AN ARRAY OF THE N ORDINATES OF THE VALUES,(I.E.Y(K)
c IS THE FUNCTIONAL VALUE CORRESPONDING TO X(K)),
c SLP1 AND SLPN CONTAIN THE DESIRED VALUES FOR THE FIRST
c DERIVATIVE OF THE CURVE AT X(I) AND X(N), RESPECTIVELY.
c IF THE QUANTITY SIGMA IS NEGATIVE THESE VALUES WILL BE
c DETERMINED INTERNALLY AND THE USER NEED ONLY FURNISH
c PLACE-HOLDING PAPAMETERS FOR SLP1 AND SLPN. SUCH PLACE-
c HOLDING PARAMETERS WILL BE IGNORED BUT NOT DESTROYED,
c YP IS AN ARRAY OF LENGTH AT LEAST N
c TEMP IS AN ARRAY OF LENGTH AT LEAST N WHICH IS USED FOR
c SCRATCH STORAGE,
c AND
c SIGMA CONTAINS THE TENSION FACTOR. THIS IS NON-ZERO AND
c INDICATES THE CURVINESS DESIRED. IF ABS(SIGMA) IS NEARLY
c ZERO (E.G. .001) THE RESULTING CURVE IS APPOXIMATELY A
c CUBIC SPLINE. IF ABS(SIGMA) IS LARGE (E.G. 50.) THE
c RESULTING CURVE IS NEARLY A POLYGONAL LINE. THE SIGN
c OF SIGMA INDICATES WHETHER THE DERIVATIVE INFORMATION
c HAS BEEN INPUT OR NOT. IF SIGMA IS NEGATIVE THE ENDPOINT
c DERIVATIVES WILL BE DETEMINED INTERNALLY. A STANDARD
c VALUE FOR SIGMA IS APPROXIMATELY 1. IN ABSOLUTE VALUE.
c ON OUTPUT--
c YP CONTAINS VALUES PROPORTIONAL TO THE SECOND DERIVATIVE
c OF THE CURVE AT THE GIVEN NODES.
c N,X,Y,SLP1,SLPN AND SIGMA ARE UNALTERED,
          nm1 = n - 1
          np1 = n + 1
          delx1 = x(2) - x(1)
          dx1=(y(2)-y(1))/delx1
c DETERMINE SLOPES IF NECESSARY
          if (sigma.lt.0.) go to 50
          slpp1 = slp1
          slppn = slpn
c DENORMALIZE TENSION FACTOR
10        sigmap = abs(sigma)*float(n-1)/(x(n)-x(1))
c SET UP RIGHT HAND SIDE AND TRIDIAGONAL SYSTEM FOR YP AND
c PERFORM FORWARD ELIMINATION
          dels = sigmap*delx1
          exps = exp(dels)
          sinhs = .5*(exps-1./exps)
          sinhin = 1./(delx1*sinhs)
          diag1 = sinhin*(dels*.5*(exps+1./exps)-sinhs)
          diagin = 1./diag1
          yp(1) = diagin*(dx1-slpp1)
          spdiag = sinhin*(sinhs-dels)
          temp(1) = diagin*spdiag
          if (n.eq.2) go to 30
          do 20 i=2,nm1
            delx2 = x(i+1) - x(i)
            dx2=(y(i+1)-y(i))/delx2
            dels = sigmap*delx2
            exps = exp(dels)
            sinhs = .5*(exps-1./exps)
            sinhin = 1./(delx2*sinhs)
            diag2 = sinhin*(dels*(.5*(exps+1./exps))-sinhs)
            diagin = 1./(diag1+diag2-spdiag*temp(i-1))
            yp(i) = diagin*(dx2-dx1-spdiag*yp(i-1))
            spdiag = sinhin*(sinhs-dels)
            temp(i) = diagin*spdiag
            dx1 = dx2
            diag1 = diag2
20        continue
30        diagin = 1./(diag1-spdiag*temp(nm1))
          yp(n) = diagin*(slppn-dx2-spdiag*yp(nm1))
c PERFORM BACK SUBSTITUTION
          do 40 i=2,n
            ibak = np1 - i
            yp(ibak) = yp(ibak) - temp(ibak)*yp(ibak+1)
40        continue
          return
50        if (n.eq.2) go to 60
c IF NO DERIVATIVES ARE GIVEN USE SECOND ORDER POLYNOMIAL
c INTERPOLATION ON INPUT DATA FOR VALUES AT ENDPOINTS.
          delx2 = x(3) - x(2)
          delx12 = x(3) - x(1)
          c1 = - (delx12+delx1)/delx12/delx1
          c2 = delx12/delx1/delx2
          c3 = -delx1/delx12/delx2
          slpp1=c1*y(1) + c2*y(2) + c3*y(3)
          deln = x(n) - x(nm1)
          delnm1 = x(nm1) - x(n-2)
          delnn = x(n) - x(n-2)
          c1 = (delnn+deln)/delnn/deln
          c2 = - delnn/deln/delnm1
          c3 = deln/delnn/delnm1
          slppn=c3*y(n-2) + c2*y(nm1) + c1*y(n)
          go to 10
c IF ONLY TWO POINTS AND NO DERIVATIVES ARE GIVEN, USE
c STRAIGHT LINE FOR CURVE
60        yp(1) = 0.
          yp(2) = 0.
          return
          end
            function cur2(t, n, x, y, yp, sigma, it)
            real t, y(1), yp(1), sigma, x(1)
c THIS FUNCTION INTERPOLATES A CURVE AT A GIVEN POINT
c USING A SPLINE UNDER TENSION. THE SUBROUTINE CURV1 SHOULD
c BE CALLED EARLIER TO DETERMINE CERTAIN NECESSARY
c PARAMETERS.
c ON INUT--
c T CONTAINS A REAL VALUE TO BE MAPPED ONTO THE INTERPO-
c LATING CURVE.
c N CONTAINS THE NUMBER OF POINTS WHICH WERE INTERPOLATED
c TO DETERMINE THE CURVE,
c X AND Y ARE ARRAYS CONTAINING THE ORDINATES AND ABCISSA
c OF THE INTERPOLATED POINTS,
c YP IS AN ARRAY WITH VALUES PROPORTIONAL TO THE SECOND
c DERIVATIVE OF THE CURVE AT THE NODES
c SIGMA CONTAINS THE TENSION FACTOR (ITS SIGN IS IGNORED)
c IT IS AN INTEGER SWITCH. IF IT IS NOT 1 THIS INDICATES
c THAT THE FUNCTION HAS BEEN CALLED PREVIOUSLY (WITH N,X,
c Y,YP, AND SIGMA UNALTERED) AND THAT THIS VALUE OF T
c EXCEEDS THE PREVIOUS VALUE. WITH SUCH INFORMATION THE
c FUNCTION IS ABLE TO RERFORM THE INTERPOLATION MUCH MORE
c RAPIDLY. IF A USER SEEKS TO INTERPOLATE AT A SEQUENCE
c OF POINTS, EFFICIENCY IS GAINED BY ORDERING THE VALUES
c INCREASING AND SETTING IT TO THE INDEX OF THE CALL.
c IF IT IS 1 THE SEARCH FOR THE INTERVAL (X(K),X(K+1))
c CONTAINING T STARTS WITH K=1.
c THE PARAMETERS N,X,Y,YP AND SIGMA SHOULD BE INPUT
c UNALTERED FROM THE OUTPUT OF CURV1.
c ON OUTPUT--
c CURV2 CONTAINS THE INTERPOLATED VALUE. FOR T LESS THAN
c X(1) CURV2 = Y(1), FOR T GREATER THAN X(N) CURV2 = Y(N)
c NONE OF THE INPUT PARAMETERS ARE ALTERED.
          s = x(n) - x(1)
c DENORMALIZE SIGMA
          sigmap = abs(sigma)*float(n-1)/s
c IF IT.NE.1 START SEARCH WHERE PREVIOUSLY TERMINATED,
c OTHERWISE START FROM BEGINNING
          if (it.eq.1) i1 = 2
c SEARCH FOR INTERVAL
10        do 20 i=i1,n
            if (x(i)-t) 20, 20, 30
20        continue
          i = n
c CHECK TO INSURE CORRECT INTERVAL
30        if (x(i-1).le.t .or. t.le.x(1)) go to 40
c RESTART SEARCH AND RESET I1
c  ( INPUT ''IT'' WAS INCORRECT )
          i1 = 2
          go to 10
c SET UP AND PERFORM INTERPOLATION
40        del1 = t - x(i-1)
          del2 = x(i) - t
          dels = x(i) - x(i-1)
          exps1 = exp(sigmap*del1)
          sinhd1 = .5*(exps1-1./exps1)
          exps = exp(sigmap*del2)
          sinhd2 = .5*(exps-1./exps)
          exps = exps1*exps
          sinhs = .5*(exps-1./exps)
          cur2 = (yp(i)*sinhd1+yp(i-1)*sinhd2)/sinhs +
     & ((y(i)-yp(i))*del1+(y(i-1)-yp(i-1))*del2)/dels
          i1 = i
          return
          end
