c  SLICE
c
c  slice will find either a row or column in a standard gridded file
c  that is entirely dvals, delete it and change row and column count and
c  x0 and y0 if necessary.  Intended to omit dvaled borders, so may cause
c  problems if internal rows or columns are totally dvaled.
c  Tien Grauch
c
      character*56 infile,outfile,temp
      dimension x(5000),id(14),pgm(2),idel(5000)
      temp='slice.tmp'
      data dval/'ffff7fff'x/
1     print 801
801   format(' 1 - slice off rows that are entirely dvals',/,
     & ' 2 - slice off columns that are entirely dvals',/,
     & ' 3 - stop',/,'      Enter option : ',$)
      read*,iopt
      if(iopt.eq.3) go to 300
      if(iopt.eq.1.or.iopt.eq.2) go to 5
      go to 1
5     print*, 'Enter input file name'
      read 802,infile
802   format(a56)
      open(10,file=infile,form='unformatted',status='old',readonly)
      read(10) id,pgm,ncol,nrow,nz,x0,dx,y0,dy
      print*, 'Enter output file name'
      read 802,outfile
      go to(10,50),iopt
10    open(11,file=temp,form='unformatted',status='new')
      write(11) id,pgm,ncol,nrow,nz,x0,dx,y0,dy
c
c  row slice
c
      itest=0
      irow=0
      do 25 i=1,nrow
      call rowrow(10,ncol,x,1)
      do 15 j=1,ncol
      if(x(j).lt.dval) go to 20
15    continue
      if(itest.ne.0) go to 25
      y0=y0+dy
      go to 25
20    itest=1
      irow=irow+1
      call rowrow(11,ncol,x,2)
25    continue
      ncol2=ncol
      nrow2=irow
      y02=y0
      x02=x0
      go to 100
c
c  column slice
c
50     do 52 i=1,5000
52    idel(i)=0
      icol=0
      itest=0
      do 70 i=1,nrow
      call rowrow(10,ncol,x,1)
      do 55 j=1,ncol
      if(x(j).ge.dval.and.idel(j).eq.0) go to 55
      idel(j)=1
55    continue
70    continue
      do 75 i=1,ncol
      if(idel(i).eq.0) go to 73
      icol=icol+1
      itest=1
      go to 75
73    if(itest.ne.0) go to 75
      x0=x0+dx
75    continue
      ncol2=icol
      nrow2=nrow
      x02=x0
      y02=y0
      close(10)
      open(10,file=infile,form='unformatted',status='old',readonly)
      go to 105
c
c  read in temporary file and write out with new cols & rows
c
100   close(10)
      close(11)
      open(10,file=temp,form='unformatted',status='old')
105   open(11,file=outfile,form='unformatted',status='unknown')
      read(10) id,pgm,ncol,nrow,nz,x0,dx,y0,dy
      pgm(1)=' sli'
      pgm(2)='ced '
      write(11) id,pgm,ncol2,nrow2,nz,x02,dx,y02,dy
      do 40 j=1,nrow2
      call rowrow(10,ncol,x,1)
      go to (39,33),iopt
33    kk=0
      do 35 k=1,ncol
      if(idel(k).eq.0) go to 35
      kk=kk+1
      x(kk)=x(k)
35    continue
      if(kk.ne.ncol2) print*, 'yipe'
39    call rowrow(11,ncol2,x,2)
40    continue
      if(iopt.eq.2)close(10)
      if(iopt.eq.1)close(10,disp='delete')
      close(11)
      go to 1
300      stop
      end
c reads or writes to standard gridded file one row at a time
c
      subroutine rowrow(iunit,ncol,row,ikey)
      dimension row(ncol)
      go to (1,2),ikey
1     read(iunit) dum,row
      return
2     write(iunit) dum,row
      return
      end
c
c  build an array of a selected column (the icolth column) from a
c  standard gridded file
