c
c              program swappost
c  rearrange the channels of a post file.
c  append multiple files.
c  binary or ascii output.
c
	parameter     maxchn=30
	dimension     ich(maxchn), z(maxchn), z2(maxchn)
	character*80  ifile, ofile, afile, ascbin, blank, ans
	data          idev, jdev, kdev/ 10, 11, 12 /
	blank = ' ' 
	ninp  = 0

1	format( a )
	type *, ' swap n-channels, winnow records and append post files'
	type *

10	type *, ' enter input post filename [ exit ] :'
	read(5,1) ifile
	nchar = leftj( ifile )
	if ( ifile .eq. blank ) go to 999
	if ( ifile(1:4) .eq. 'exit' .or.  
	1    ifile(1:4) .eq. 'EXIT' ) go to 999

	open( idev, file=ifile, status='old', form='unformatted',
	1    iostat=ierr, readonly )
	if ( ierr .ne. 0 ) go to 10

	ninp  = ninp + 1
	nchan = lenrec( idev, ich, 30 ) - 2

	type *, ' number of channels =', nchan
	if ( ninp .eq. 1 ) then
	  nchan1 = nchan
	  nz     = nchan
	endif
	if ( ninp .gt. 1   .and.  nchan .ne. nchan1 ) then
	  type *, ' warning: nchannel not same as first file'
	  write(6,*)  ' number of channels output =', nchan1
	  write(kdev,*) ' number of channels output =', nchan1
	endif

	if ( ninp .gt. 1 ) go to 50

	type *, ' enter output filename :'
	read(5,1) ofile
	if ( ofile .eq. blank ) then
	  ofile = ' swappost.out'
	  nchar = 12
	  write(6,*) ' output file = ', ofile(1:nchar)
	endif

c  open listing file

	call getfn( ofile, 'swap', afile )
	nchar = leftj( afile )
	type *, ' channel assignment file is ', afile(1:nchar)
	open( kdev, file=afile, status='new', form='formatted' )

c  output type

	type *, ' enter output type either ascii or [ binary ] :'
	read(5,1) ascbin
	nchar = leftj( ascbin )
	if ( ascbin .eq. blank ) ascbin = 'unformatted'
	if ( ascbin(1:1) .eq. 'a'  .or.  ascbin(1:1) .eq. 'A' )
	1                        ascbin = 'formatted'
	if ( ascbin(1:1) .eq. 'b'  .or.  ascbin(1:1) .eq. 'B' )
	1                        ascbin = 'unformatted'

	open(jdev, file=ofile, status='new', form=ascbin )
	iform = 0
	if ( ascbin(1:1) .eq. 'f' ) iform = 1

	write(kdev,*) 
	write(kdev,*) '      program swappost ' 
	nchar = leftj( ofile )
	write(kdev,*)
	write(kdev,*) ' output file =', ofile(1:nchar)

c  channel selection

30	type *, ' enter number of output channels [ 0 (no reordering) ]'
	read(5,1,err=30) ans
	nz2 = 0
	if ( ans .ne. blank ) read(ans,*,err=30) nz2
	if ( nz2 .gt. maxchn ) then
	  type *, ' maximum number of channel =', maxchn
	  go to 30
	endif
	if ( nz2 .gt. 0 ) then
	  type *, ' enter the input channels in order they are'
	  type *, ' to appear in the output file'

	  read(5,*,err=30,end=30) ( ich(i), i=1, nz2 )
	  type *, ( ich(i), i=1, nz2 )
	  type *, ' is this correct ? [ n ] '
	  if ( noyes() .le. 0 ) go to 30

	  write(kdev,*)
	  write(kdev,40) ( ich(i), i=1, nz2 )
40	  format( /,' channel assignments', 2(10i4,/) )
	endif

c  winnowing factor

	type *, ' enter record winnowing factor [ 0 (no winnowing) ]'
	nwin = 0
	read(5,1) ans
	if ( ans .ne. blank ) read(ans,*,err=30,end=30) nwin
	if ( nwin .le. 0 ) nwin = 0
	if ( nwin .gt. 0 ) then
	  write(kdev,*)
	  write(kdev,*) ' winnowing factor =', nwin
	endif

c  process ifile

50	nchar = leftj( ifile )
	write(kdev,*) 
	write(kdev,*) ' input file =', ifile(1:nchar)

	if ( nz2 .gt. 0 ) then
	  call swap1( idev, jdev, nwin, iform, icnt1, icnt2, 
	1             z, nz, ich, z2, nz2 )
	  else
	  call swap2( idev, jdev, nwin, iform, icnt1, icnt2,
	1             z, nz )
	endif

99	type *, icnt1, icnt2, ' records in,out'
	write(kdev,101) icnt1, icnt2
101	format( ' number of records in,out = ', 2i8 )
	close( idev )
	go to 10

999	stop
	end
c*******************************************************************************
	subroutine swap1( idev, jdev, nwin, iform, icnt1, icnt2,
	1                 z, nz, ich, z2, nz2 )
	dimension  z(nz), ich(nz2), z2(nz2)
	character  id*8

	icnt1 = 0
	icnt2 = 0
	nskip = nwin - 1

	do irec = 1, 9 999 999
	  read(idev,end=99) id, z
	  icnt1 = icnt1 + 1

	  if ( nwin .gt. 0 ) then
	    do i = 1, nskip
	      read(idev,end=99)
	      icnt1 = icnt1 + 1
	    enddo
	  endif

	  do i2 = 1, nz2
	    z2(i2) = z( ich(i2) )
	  enddo

	  if ( iform .eq. 0 ) then
	    write(jdev) id, z2
	    icnt2 = icnt2 + 1
	    else
	    write(jdev,*) id, z2
	    icnt2 = icnt2 + 1
	  endif

	enddo
99	return
	end
c*******************************************************************************
	subroutine swap2( idev, jdev, nwin, iform, icnt1, icnt2,
	1                 z, nz )
	dimension z(nz)
	character id*8

	icnt1 = 0
	icnt2 = 0
	nskip = nwin - 1

	do irec = 1, 9 999 999
	  read( idev, end=99 ) id, z
	  icnt1 = icnt1 + 1

	  if ( nwin .gt. 0 ) then
	    do i = 1, nskip
	      read(idev,end=99)
	      icnt1 = icnt1 + 1
	    enddo
	  endif

	  if ( iform .eq. 0 ) then
	    write(jdev) id, z
	    icnt2 = icnt2 + 1
	    else
	    write(jdev,*) id, z
	    icnt2 = icnt2 + 1
	  endif

	enddo
99	return
	end
c******************************************************************************
	subroutine getfn(ifile,suffix,ofile)
c  strip off old extension and specified device/directory and add new suffix.
c  VAX filename conventions:    device:[directory]filename.extension
c  directory is level(n).level(n+1).level(n+2)...
	character ifile*(*),suffix*(*),ofile*(*)

	lenin = len(ifile)
	lenou = len(ofile)
	ofile = ' '
c  strip off device/directory and default to the working directory
	m = index(ifile,']') + 1
	n = lenin - m + 1
	ofile(1:n) = ifile(m:lenin)

c  find nonblank length
10	lennb=0
	do i = n, 1, -1
	  if(ofile(i:i).ne.' ' .and. lennb.eq.0) lennb=i
	enddo
	if(lennb.eq.0) then
	  type *,' getfn: cannot parse filename, enter new prefix'
	  type *,'        to go with the suffix ',suffix
	  read(5,*,err=10) ofile
	  go to 10
	endif

c  terminate prefix with period.
	n = index(ofile,'.')
	if (n .eq. 0) then
	  n = lennb + 1
	  ofile(n:n)='.'
	endif	

	m = n + 1
	lens = len(suffix)
	n = n + lens
	ofile(m:n) = suffix(1:lens)

	do i = n+1, lenou
	  ofile(i:i) = ' '
	enddo
	return
	end
c******************************************************************************
	function lenrec( iswt, irec, nwork )
c  brute force recovery of record length
	dimension irec(nwork)

	istep = 10
	if ( nwork .gt. 100 ) istep = 20
	if ( nwork .gt. 500 ) istep = 50
	rewind iswt

	do max = istep, nwork, istep
	  read( iswt, err=10 ) ( irec(i), i=1, max )
	  rewind iswt
	enddo
	lenrec = -1
	go to 99

10	rewind iswt
	do lenrec = max, max - istep, -1
	  read( iswt, err=20 ) ( irec(i), i=1, lenrec )
	  go to 99
20	  rewind iswt
	enddo

99	rewind iswt
	return
	end
c******************************************************************************
	function noyes()
c  returns -1 for indeterminate, 0 for no, 1 for yes
	character  inp*4, blank*4
	data       blank/ '    ' /

	icnt  = 0
	noyes = -1

1	inp   = ' '
	read ( 5, 2, end=5, err=5 ) inp
2	format( a )
	if ( inp .eq. blank ) return

	do 3 n = 1, 4
	  if ( inp(n:n) .ne. ' ' ) then
	    if ( inp(n:n).eq.'y' .or. inp(n:n).eq.'Y' ) noyes = 1
	    if ( inp(n:n).eq.'n' .or. inp(n:n).eq.'N' ) noyes = 0
	    if ( noyes .gt. -1 ) return
	    go to 5
	  endif
3	continue

5	if ( icnt .lt. 3 ) then
	  icnt = icnt + 1
	  write( 6, * ) ' <cr>, no, or yes :'
	  go to 1
	endif

	write( 6, * ) ' count exceeded, returning indeterminate state '
9	return
	end
c******************************************************************************
	function leftj(a)
c  left justifies a string and returns the position
c  of the last nonblank character
	character a*(*)
	n = len(a)
	ich = ichar(a(1:1))
	if (ich.ne.0 .and. ich.ne.32) go to 15
	do 1 m = 2, n
	ich = ichar(a(m:m))
1	if (ich.ne.0 .and. ich.ne.32) go to 5
	leftj = 0
	return
c
5	i2 = 0
	do 10 i = m, n
	i2 = i2 + 1
	a(i2:i2) = a(i:i)
10	continue
	do 11 i3 = i2+1, n
11	a(i3:i3) = ' '
	n = n-m+1
c
15	do 20 leftj = n, 1, -1
	ich = ichar(a(leftj:leftj))
20	if (ich.ne.0 .and. ich.ne.32) go to 25
25	return
	end
