c  program tideplot
c  mike webring, usgs, 1/83
	common /smtide/ gs,gm
	dimension mlen(12),tidem(49),stide(49),x(49),zero(49),t(49)
	dimension ititl(20),idate(2)
	character titl*80,date*8
	double precision year,at,xlat,xlatm,xlon,xlonm,
	1 elev,hour,xmin,gmt,gs,gm
	equivalence (ititl,titl),(idate,date)
	data xmin/0.d0/,mlen/31,28,31,30,31,30,31,31,30,31,30,31/
	x(1) = 0.0
	do i = 2, 49
	  x(i) = x(i-1) + .5
	enddo
	type  1
1	format(' enter latd,latm,lond (+West),lonm')
	read(5,*) xlat,xlatm,xlon,xlonm
37	format(a50)
	type  3
3	format(' enter elevation in feet :'$)
	read(5,*) elev
	elev=elev*.3048
	type  4
4	format(' enter starting month day year :'$)
	read(5,*) month,iday,iyear
	if(iyear.gt.200) iyear=iyear-1900
	zone=(xlon+xlonm/60.)/15.
	type 12,zone
12	format(' selected location is',f5.2,' hours (zones) from Greenwich',
	1 /,' PST=8, MST=7, for daylight time subtract one zone')
	type 6
6	format(' enter time zone :'$)
	read(5,*) gmt
	type  5
5	format(' how many days:'$)
	read(5,*) ndays
	lat=int(sngl(xlat))
	flatm=sngl(xlatm)
	lon=int(sngl(xlon))
	flonm=sngl(xlonm)
	call clrscr(1)
c
	do 20 j = 1, ndays
	call setplt(1)
	hour=0.d0
80	mlen(2)=28
	if(mod(iyear,4).eq.0) mlen(2)=29
	if (iday .gt. mlen(month)) then
	  iday = iday - mlen(month)
	  month = month + 1
	  if (month.gt.12) then
	    month = 1
	    iyear = iyear + 1
	  end if
	end if
	if(iday.gt.mlen(month)) go to 80
	do 10 i = 1, 49
	  year = dble(float(iyear))
	  call tides(hour,xmin,gmt,iday,month,year,elev,
	1           xlat,xlatm,xlon,xlonm,at)
	  t(i)=1000.*sngl(at)
	  stide(i)=1000.*sngl(gs)
	  tidem(i)=1000.*sngl(gm)
	  hour=hour+.5d0
10	continue
	call line(x,zero,49,0,0)
	call line(x,t,49,0,0)
	call line(x,stide,49,0,5)
	call line(x,tidem,49,0,1)
	write(date,101) month,iday,iyear
101	format(2(i2,'/'),i2)
	call vchar(3.,.25,idate,8,3,.1,0.,0.,0.)
	write(titl,100) lat,flatm,lon,flonm,gmt
100	format(' lat,lon',i4,f6.2,i7,f6.2,'  time zone ',f5.2)
	call vchar(1.,.1,ititl,48,3,.1,0.,0.,0.)
	titl=' moontide line - - - -   suntide line --- - - ---'
	call vchar(1.,5.,ititl,50,3,.08,0.,0.,0.)
	call endpt(1)
	iday=iday+1
20	continue
	call clrscr(2)
	stop
	end
c*******************************************************************************
	subroutine setplt(iplotr)
	dimension ifmt(5),xp(4),yp(4),dxp(2),dyp(2)
	character fmt*20
	equivalence (fmt,ifmt)
	data xp/4*0./,yp/4*0./
	fmt = '(f5.0)'
	call pltset(iplotr, xp(4), yp(4), isc)
	dyp(2)=240.
	dyp(1)=-140.
	dxp(2)=24.
	dxp(1)=0.
	if (iplotr.ne.1) then
	  xp(4) = 10.0
	  yp(4) =  8.0
	endif
	xp(1) = xp(4) - 1.25
	yp(1) = yp(4) - 1.25
	xp(3) = .5
	yp(3) = .75
	call scale(dxp,dyp,xp,yp,4,ier)
	call xaxis(dxp,dyp,xp,.5,4,.08,ifmt,4)
	call yaxis(dyp,dxp,yp,10.,2,.08,ifmt,4)
	return
	end
c*******************************************************************************
      subroutine tides(hrsr,xmin,gmt,iday,month,yrs,elev,xlat,xlatm,
     &  xlon,xlonm,grav)
c  computation routine for tides revised by Ron Wahl, 12 sep 74
c  ref geophysics monograph no 16, r.a. brouche  (?)
c  positive west longitude, elev in meters, grav in mgals
      implicit real*8         (a-h,o-z)
	common /smtide/gs,gm
      dimension mthday(12)
      data mthday/0,31,59,90,120,151,181,212,243,273,304,334/
      idate=iday+mthday(month)
      iyears=yrs
      if (mod(iyears,4).eq.0.and.month.gt.2)  idate=idate+1
      daysr=dfloat(idate)
      daysq=yrs*365.d0+daysr-.5d0+dfloat(idint((yrs-1.d0)*.25d0+
     & 1.d-6))
      hrsd=xmin*.01666666666667d0+gmt+hrsr
      daysd=daysq+.041666666666667d0*hrsd
      ht=elev*1.d-9
      t=daysd*2.737850787d-5
      ta=dfloat(idint(t*100.d0+1.d-6))*1.d-2
      tc=(t-ta)*100.d0
      tb=ta*1336.d0
      tb=360.d0*(tb-dfloat(idint(tb)))
      al=(xlat+xlatm*.0166666666666667d0)*.0174532925199433d0
      cosal=dcos(al)
      sinal=dsin(al)
      cos2al=cosal*cosal
      r=ht+6.37816d-3*(.99664712d0+cos2al*(3.381028d-3
     & -cos2al*2.8152d-5))
      a=13.36d0*tc
      b=dfloat(idint(a))
      c=(a-b)*360.d0+tb
  100 s=270.43435833d0+c+t*(307.883141667d0+t*(-1.13333d-3+t*
     & 1.888888d-6))
      s=dmod(s,360.d0)*.0174532925199433d0
      a=11.d0*t
      b=dfloat(idint(a))
      c=(a-b)*360.d0
  110 p=334.32965777d0+c+t*(109.03403d0+t*(-1.0325d-2-t*1.25d-5))
      p=dmod(p,360.d0)*.0174532925199433d0
      c=360.d0*tc
  120 h=279.69668d0+c+t*(.768925d0+3.03d-4*t)
      h=dmod(h,360.d0)*.0174532925199433d0
      a=5.d0*t
      b=dfloat(idint(a))
      c=(a-b)*360.d0
  130 oln=259.183275d0-c+t*(-134.14201d0+t*(2.07777d-3+t*2.d-6))
      oln=dmod(oln,360.d0)
      if (oln.lt.0.d0)  oln=oln+360.d0
      oln=oln*.0174532925199433d0
      sinoln=dsin(oln)
      cosoln=dcos(oln)
      ci=.91369d0-0.03569d0*cosoln
      si=dsqrt(1.d0-ci*ci)
      sinsi=sinoln/si
      sn=.08968d0*sinsi
      cn=dsqrt(1.d0-sn*sn)
      sit=.39798d0*sinsi
      cit=cosoln*cn+.91739d0*sinoln*sn
      tit=sit/(1.d0+cit)
      et=2.d0*datan(tit)
      if (et.lt.0.d0)  et=et+6.28318530717958d0
      cxi=oln-et
      sig=s-cxi
      smp=s-p
      sinsmp=dsin(smp)
      cossmp=dcos(smp)
      sm2hp=s-h-h+p
      smhx2=2.d0*(s-h)
      olm=sig+sinsmp*(.1098d0+7.535024d-3*cossmp)+.0154003d0*
     & dsin(sm2hp)+9.75199d-3*dsin(smhx2)
      v=datan2(sn,cn)
      ha=(15.d0*(hrsd-12.d0)-xlon-xlonm*.016666666666667d0)*
     & .0174532925199433d0
      chis=ha+h
      chi=chis-v
      sinolm=dsin(olm)
      ct=sinal*si*sinolm+0.5d0*cosal*((1.d0+ci)*dcos(olm-chi)
     & +(1.d0-ci)*dcos(olm+chi))
      da=2.59356456d0+cossmp*(.14325025d0+.01572888d0*cossmp)
     & +.0200919d0*dcos(sm2hp)+.01859186d0*dcos(smhx2)
      ct2=ct*ct
      gm=r*da*da*da*.49049d0*(3.d0*ct2-1.d0+1.5d0*r*da*ct*
     & (5.d0*ct2-3.d0))
      es=.01675104d0-t*(4.18d-5+t*1.26d-7)
      ps=281.22083d0+t*(1.71902d0+t*(4.53d-4+t*3.d-6))
      ps=dmod(ps,360.d0)*.0174532925199433d0
      hmps=h-ps
      ols=h+2.d0*es*dsin(hmps)
      ds=6.684559d-3*(1.d0+es*dcos(hmps)/(1.d0-es*es))
      cf=.39798d0*sinal*dsin(ols)+cosal*(.95869d0*
     & dcos(ols-chis)+.0413d0*dcos(ols+chis))
      gs=13.2916d6*r*(3.d0*cf*cf-1.d0)*ds*ds*ds
      grav=1.2d0*(gm+gs)
  140 return
      end
c******************************************************************************
	subroutine clrscr(iop)
c   iop=1 (or ne 2) exit in Tektronix mode,
c   iop=2 exit in ANSI character mode
c   "0g is a Digital Engineering Retrographics command 
	call sendesc('"0g')
	call sendesc('[2J')
	call sendesc('[1;1H')
	call sendesc(char(29))
	call sendesc(char(12))
	if(iop.eq.2) call sendesc('"0g')
	return
	end
c******************************************************************************
	subroutine sendesc(tail)
	character head*2,tail*(*)
	equivalence (nullesc,head)
	data nullesc/'00001b00'x/
	n=len(tail)
	write(6,1) head,tail
1	format(a2,a<n>)
	return
	end
