c               program tilt
c  surface generation with specified edge gradients
c  f(x,y) = a*dx + b*dy + c*dx*dy + dc
	dimension s(4),g(4),p(4)
	dimension r(1500),r2(1500)
	character*56 f1,f2,f3,id
	character pgm*8,ext1*4,ext2*4
	data dval,fltbig/'ffff7fff'x, 1.e29/, ext1,ext2/'.tlt', '.srf'/
	type  10
10	format(' enter input grid filename :'$)
	read(5,37) f1
37	format(a56)
	open (10,file=f1,form='unformatted',status='old',readonly)
	type 11
11	format(' enter output prefix :'$)
	read(5,37) f1
	n = leftj(f1)
	np = index(f1(1:n),'.')
	if (np.gt.0) n = np-1
	f2 = f1(1:n)//ext1
	open(11,file=f2,form='unformatted',status='new')
	f3 = f1(1:n)//ext2
	open(12,file=f3,form='unformatted',status='new')
	type *,'  tilted data grid filename is ',f2(1:n+4)
	type *,' generated surface filename is ',f3(1:n+4)
c
	read(10) id,pgm,nc,nr,nz,xo,dx,yo,dy
	type *,'title = ',id
	type *,'ncol,nrow = ',nc,nr
	type *,'xo,yo, dx,dy = ',xo,yo,dx,dy
	wx = dx*float(nc-1)
	wy = dy*float(nr-1)
c
19	type 20
20	format(' help specifying gradients ? ',$)
	if(noyes(ldum).eq.1) then
	  type *,' Gradient locations are counterclockwise from the'
	  type *,' lower-left: g(1) is bottom, g(2) is right side, etc.'
	  type *,' in z units per x units (ie. gammas per kilometer).'
	  type *,' The dependent gradient is 999.'
	  type *,' DC is the value of the lower-left corner.'
	endif
	type *,' enter dc, and gradients 1 to 4 :'
	read(5,*,end=19,err=19) p(1),g
c
c  derive dependent gradient
	i2=0
	do i=1,4
	  if(abs(g(i)-999.0).lt.0.01) i2=i
	enddo
	if(i2.eq.0) then
	  type *,' one gradient must equal 999'
	  go to 19
	endif
	g(i2) = 0.
	s(1) = g(1)*wx
	s(2) = g(2)*wy
	s(3) = g(3)*wx
	s(4) = g(4)*wy
	s(i2) = (s(1)+s(2)) - (s(3)+s(4))
	if (i2.le.2) s(i2) = -s(i2)
	g(i2) = s(i2)/wx
	if (i2.eq.2 .or. i2.eq.4) g(i2) = s(i2)/wy
60	type  70,g
70	format(' edge gradients: ',1p4g11.4)
c
c  calculate corner values
	p(2) = g(1)*wx + p(1)
	p(3) = g(4)*wy + p(1)
	p(4) = g(3)*wx + p(3)
	chk  = g(2)*wy + p(2)
	if (abs(p(4)-chk).gt.1.e-2) type *,'closure error', p,chk
c  surface coefficients
	a = (p(2)-p(1))/wx
	b = (p(3)-p(1))/wy
	c = (p(4)+p(1)-p(2)-p(3)) / (wx*wy)
	type *,' surface coordinate system origin (0,0) at lower left'
	type *,' grid corner, x & y in horizontal data units'
	type *, 'surface coefficients f(x,y) = a*x + b*y + c*x*y + dc'
	type *, a,b,c,p(1)
c
	pgm='tilt'
	write(11) id,pgm,nc,nr,nz,xo,dx,yo,dy
	write(id,150) a,b,c,p(1)
150	format('ax+by+cxy+d ',1p4g11.3)
	write(12) id,pgm,nc,nr,nz,xo,dx,yo,dy
c
	do j = 1, nr
	call rowio(nc,r,-1,10,10,ie)
	y = dy*float(j-1)
	byp = b*y + p(1)
	cy  = c*y
	do i = 1, nc
	  x = dx*float(i-1)
	  r2(i) =  x*(a+cy) + byp  	
	  if (r(i).lt.fltbig) then
	    r(i) = r(i) + r2(i)
	    else
	    r(i) = dval
	  endif
	enddo
	call rowio(nc,r,0,11,11,ie)
	call rowio(nc,r2,0,12,12,ie)
	enddo
c
	close(11)
	close(12)
	close(13)
	stop
	end
c******************************************************************************
	function noyes()
c  returns -1 for indeterminate, 0 for no, 1 for yes
	character  inp*4, blank*4
	data       blank/ '    ' /

	icnt  = 0
	noyes = -1

1	inp   = ' '
	read ( 5, 2, end=5, err=5 ) inp
2	format( a )
	if ( inp .eq. blank ) return

	do 3 n = 1, 4
	  if ( inp(n:n) .ne. ' ' ) then
	    if ( inp(n:n).eq.'y' .or. inp(n:n).eq.'Y' ) noyes = 1
	    if ( inp(n:n).eq.'n' .or. inp(n:n).eq.'N' ) noyes = 0
	    if ( noyes .gt. -1 ) return
	    go to 5
	  endif
3	continue

5	if ( icnt .lt. 3 ) then
	  icnt = icnt + 1
	  write( 6, * ) ' <cr>, no, or yes :'
	  go to 1
	endif

	write( 6, * ) ' count exceeded, returning indeterminate state '
9	return
	end
c******************************************************************************
	subroutine rowio(n,z,iop,idev,jdev,iend)
c  read iop<0, write iop=0, r&w iop=1
	dimension z(n)
	iend=0
	if(iop)1,2,1
1	read(idev,end=10) y,z
	if(iop)9,9,2
2	write(jdev) y,z
9	return
10	iend=1
	return
	end
c******************************************************************************
	function leftj(a)
c  left justifies a string and returns the position
c  of the last nonblank character
	character a*(*)
	n = len(a)
	ich = ichar(a(1:1))
	if (ich.ne.0 .and. ich.ne.32) go to 15
	do 1 m = 2, n
	ich = ichar(a(m:m))
1	if (ich.ne.0 .and. ich.ne.32) go to 5
	leftj = 0
	return
c
5	i2 = 0
	do 10 i = m, n
	i2 = i2 + 1
	a(i2:i2) = a(i:i)
10	continue
	do 11 i3 = i2+1, n
11	a(i3:i3) = ' '
	n = n-m+1
c
15	do 20 leftj = n, 1, -1
	ich = ichar(a(leftj:leftj))
20	if (ich.ne.0 .and. ich.ne.32) go to 25
25	return
	end
