c
c  program xyzmax
c  upgraded to handle n-channel post files and express files.
c
c  m webring, usgs
c
	parameter  ( maxbuf=1024, maxpst=52, maxchn=maxpst-2 )
	dimension  buff(1024), xmin(maxchn), xmax(maxchn), za(maxchn)
	character  ifile*80, id*8, ifmt*80, blank*80
	logical    binary, expres, post

1	format( a )
	iswt  = 10
	ifmt  = ' '
	blank = ' '
	post  = .false.
	ic    = 0

c  standard gravity format
	ifmt = '(22x,f2.0,f4.2,f4.0,f4.2,f6.2)'

	do i = 1, maxchn
	  xmin(i) = 1.e30
	  xmax(i) = -xmin(i)
	enddo

	type 10
10	format(' enter filename :'$)
	read(5,1) ifile

	call openf( iswt, ifile, buff, maxpst, binary, expres,
	1           nword, maxlog, ntotal )

c  set function switches
	ifunc = 0
	if ( binary  .and.  nword .gt. 3 ) then
	  ifunc = 2
	  post  = .true.
	endif
	if ( binary  .and.  nword .eq. 3 ) then
	  ifunc = 3
	  post  = .false.
	endif
	if ( expres ) ifunc = 1

	if ( ifunc .eq. 0 ) then
20	  type *, ' enter 4 ( formatted xyz ) or 5 ( standard gravity ) :'
	  read( 5, *, err=20 ) ifunc
	  if ( ifunc .lt. 4   .or.   ifunc .gt. 5 ) go to 20
	endif

	nchn = nword - 2
	is   = 1
	ie   = 3

	if ( post ) then
59	  type *, ' enter starting and ending channel numbers :'
	  read(5,*) is, ie
	  if ( ie .gt. nchn ) go to 59
	  if ( is .le. 0    ) go to 59
	  if ( is .gt. ie   ) go to 59

	  else if (ifunc .eq. 4 ) then
	    type *, ' enter format ( car ret for free field ) :'
	    read(5,1) ifmt
	    if ( ifmt .eq. blank ) ifunc = 6

	    else if ( ifunc .eq. 5 ) then
	      do 80 i = 1, 3
80	      read( iswt, ifmt, end=999 )
	endif

c  start read loop 
	go to ( 110, 120, 130, 140, 150, 160 ) ifunc

110	call expr( iswt, buff, nword, maxlog, is, ie, 
	1          xmin, xmax, maxchn, ic )
	go to 200

120	call postr( iswt, za, ie,   is, ie, 
	1          xmin, xmax, maxchn, ic )
	go to 200

130	read( iswt, end=200 ) x, y, z
	go to 190

140	read( iswt, ifmt, end=200 ) x, y, z
	go to 190

150	read( iswt, ifmt, end=200 ) yd,ym,xd,xm,z
	x = xd + xm * sign( 1.666667e-2, xd )
	y = yd + ym * 1.666667e-2
	go to 190

160	read( iswt, *, end=200 ) x, y, z

190	ic = ic + 1
	if ( x .lt. xmin(1) ) xmin(1) = x
	if ( x .gt. xmax(1) ) xmax(1) = x
	if ( y .lt. xmin(2) ) xmin(2) = y
	if ( y .gt. xmax(2) ) xmax(2) = y
	if ( z .lt. xmin(3) ) xmin(3) = z
	if ( z .gt. xmax(3) ) xmax(3) = z
	go to ( 110, 120, 130, 140, 150, 160 ) ifunc

200	continue

	do i = is, ie
	  rang = xmax(i) - xmin(i)
	  type 230, i, xmin(i), xmax(i), rang
230	  format(' #', i2, ' min= ', 1pg15.6, '  max= ', g15.6,
	1                  ' range=',g15.6 )
	enddo

240	type *, ic, ' logical records in the file'
	close(10)
	stop
999	close(10)
	stop ' premature end of file'
	end
c******************************************************************************
	subroutine postr( iswt, z, nchn, is, ie, 
	1                xmin, xmax, maxchn, ic )
	dimension z(nchn), xmin(maxchn), xmax(maxchn)
	character id*8

	ic=0
5	read(10,end=99) id, z
	ic = ic + 1
	do i = is, ie
	  if ( z(i) .lt. xmin(i) ) xmin(i) = z(i)
	  if ( z(i) .gt. xmax(i) ) xmax(i) = z(i)
	enddo
	go to 5
99	return
	end
c*******************************************************************************
	subroutine expr( iswt, buff, nword, maxlog, is, ie, 
	1                xmin, xmax, maxchn, ndat )

	dimension  buff(nword,maxlog), xmin(maxchn), xmax(maxchn)

	ncharw = 0
	if ( nword .gt. 3 ) ncharw = 2

	nrec = 0
	ntxt = 0
	ndat = 0

	do 100 irec = 1, 9 999 999

	  read( iswt, rec=irec, err=200 ) nw, nlog, nt, buff
	  nrec = nrec + 1
	  if ( nlog .lt. 0 ) then 
	    ntxt = ntxt + 1
	    go to 100
	  endif

	  do j = 1, nlog
	    ndat = ndat + 1
	    do i = is, ie
	      b = buff(i+ncharw,j)
	      if ( b .lt. xmin(i) ) xmin(i) = b
	      if ( b .gt. xmax(i) ) xmax(i) = b
	    enddo
	  enddo

100	continue

200	type *, ' total number of records in file =', nrec
	type *, ' number of text records          =' , ntxt

	return
	end
c*******************************************************************************
	subroutine openf( iswt, ifile, buff, maxpst, binary, expres,
	1                 nword, maxlog, ntotal )

c  open data file, derive and checkout file structure.
c
c  input file types:
c  xyz      single record xyz data.
c  post     single record containing an id (8 characters), float(1-nchannel).
c           maximum record length = maxpst ( normally about 52 )
c  express  a blocked form of either xyz or post records with 3 words
c           of size information preceeding the data entrys.
c           nword  =  3 for xyz records
c                  =  2 + nchannel for post records.
c           nlog   =  number of logical records in this express record.
c                     can range from zero to maxlog where 
c                     maxlog = int( ntotal / nword ).
c                     ignore nlog < zero  ( text records ).
c           ntotal =  number of words in the data array so that dimensions
c                     are either buffer(nword,maxlog) or buffer(ntotal).
c           nword and ntotal are constant in a given express file.

	parameter  ( maxbuf=1024 )
	dimension  buff(maxbuf)
	character  ifile*(*)
	logical    binary, expres
	nword  = 0
	maxlog = 0
	ntotal = 0
	binary = .false.
	expres = .false.

c  open binary
	open( unit=iswt, file=ifile, status='old', form='unformatted',
	1     readonly, iostat=ios )
	if ( ios .ne. 0 ) then
	  type *,' error opening input data file ( cannot find )'
	  stop
	endif

c  binary or ascii input ?
	read( iswt, err=10, iostat=ios ) itest
10	rewind( iswt )
	if ( ios .eq. 0 ) then
	  binary = .true. 
	  else
	  close( iswt ) 
	  go to 100
	endif

c  file is binary
c  lenrec returns zero if buffer is too short
	nword = lenrec( iswt, buff, maxpst )
	if ( nword .eq. 1  .or.  nword .eq. 2 ) go to 200

c  simple xyz file.
	if ( nword .eq. 3 ) then
	  type *, ' binary xyz data'
	  go to 999
	endif

c  simple post file.
	if ( nword .ge. 4   .and.   nword .le. maxpst ) then
	  nchan  = nword - 2
	  type *, ' post data,  found', nchan, ' data channels'
	  go to 999
	endif

c  open for express input
	close( iswt )
	open( unit=iswt, file=ifile, status='old', form='unformatted',
	1     access='direct', iostat=ios, readonly )
	if ( ios .ne. 0 ) then
	  type *,' error opening input data file ( not random access )'
	  stop
	endif
	expres = .true.
	type *, ' express data format'

c  read past text records to get a data record.
	do irec = 1, 10
	  read( iswt, rec=irec, err=50, iostat=ios ) nword, nlog, ntotal
50	  if ( ios .ne. 0 ) then
	    type *, ' error reading file while deriving nlog'
	    stop
	  endif
	  if ( nlog .gt. 0 ) go to 60
	enddo

c  check express file parameters
60	ierror = 0
	if ( nword * nlog .gt. ntotal ) ierror = 2
	if ( nword .le. 0   .or.  ntotal .le. 0 ) ierror = 3
	if ( ierror .ne. 0 ) then
	  type *, ' express file error'
	  type *, ' record length (recl) =', length
	  type *, ' nword, ntotal        =', nword, ntotal
	  type *, ' number of data entrys for the first record=', nlog
	  go to 999
	endif

	maxlog = ntotal / nword

	if ( nword .eq. 1  .or.  nword .eq. 2 ) go to 200
	if ( nword .eq. 3 ) then
	  type *, ' found xyz records'
	  else
	  nchan = nword - 2
	  type *, ' found post records,  with', nchan, ' data channels'
	endif
	go to 999

c  open for ascii input
100	  open( unit=iswt, file=ifile, status='old', form='formatted', 
	1       readonly )
	go to 999

c  record length undefined.
200	type *, ' input record length =', nword
	type *, ' input is neither xyz or post'

999	return
	end
c******************************************************************************
	function lenrec( iswt, irec, nwork )
c  brute force recovery of record length
	dimension irec(nwork)

	istep = 10
	if ( nwork .gt. 100 ) istep = 20
	if ( nwork .gt. 500 ) istep = 50
	rewind iswt

	do max = istep, nwork, istep
	  read( iswt, err=10 ) ( irec(i), i=1, max )
	  rewind iswt
	enddo
	lenrec = -1
	go to 99

10	rewind iswt
	do lenrec = max, max - istep, -1
	  read( iswt, err=20 ) ( irec(i), i=1, lenrec )
	  go to 99
20	  rewind iswt
	enddo

99	rewind iswt
	return
	end
